﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

namespace Learn
{
    /// <summary>
    /// Логика взаимодействия для ListService.xaml
    /// </summary>
    public partial class ListService : Page
    {
        bool flag = false;
        int global_count = 0;
        public ListService()
        {
            InitializeComponent();
            Entities BD = new Entities();
            Services.ItemsSource = BD.Service.ToList();
            Sales.ItemsSource = new List<string>() { "Все", "от 0% до 5%", "от 5% до 15%", "от 15% до 30%", "от 30% до 70%", "от 70% до 100%" };
            Sales.SelectedIndex = 0;
            global_count = Services.Items.Count;
            global.Text = "Количество записей " + global_count + " из " + BD.Service.Count();
        }
        public ListService(int i)
        {
            InitializeComponent();
            Entities BD = new Entities();
            Services.ItemsSource = BD.Service.ToList();
            Sales.ItemsSource = new List<string>() { "Все", "от 0% до 5%", "от 5% до 15%", "от 15% до 30%", "от 30% до 70%", "от 70% до 100%" };
            Sales.SelectedIndex = 0;
            global_count = Services.Items.Count;
            global.Text = "Количество записей " + global_count + " из " + BD.Service.Count();
            flag = true;
        }

        private void DelEditLoad(object sender, RoutedEventArgs e)
        {
            StackPanel deledit = (StackPanel)sender;
            if (flag == true)
            {
                deledit.Visibility = Visibility.Visible;
            }
        }
        private void VisAdd(object sender, RoutedEventArgs e)
        {
            Border add = (Border)sender;
            if (flag == true)
            {
                add.Visibility = Visibility.Visible;
            }
        }

        private void VisRec(object sender, RoutedEventArgs e)
        {
            Border view = (Border)sender;
            if (flag == true)
            {
                view.Visibility = Visibility.Visible;
            }
        }


        private void Strike(object sender, RoutedEventArgs e)
        {
            TextBlock OldPrice = (TextBlock)sender;
            Entities BD = new Entities();
            int id = Convert.ToInt32(OldPrice.Uid);
            double enable = Convert.ToDouble(BD.Service.Where(x => x.ID == id).Select(x => x.Discount).First());
            if (enable != 0)
            {
                OldPrice.Visibility = Visibility.Visible;

            }
            else
            {
                OldPrice.Visibility = Visibility.Collapsed;
            }
        }

        private void PriceLoad(object sender, RoutedEventArgs e)
        {
            TextBlock Price = (TextBlock)sender;
            Entities BD = new Entities();
            int id = Convert.ToInt32(Price.Uid);
            double disc = Convert.ToDouble(BD.Service.Where(x => x.ID == id).Select(x => x.Discount).First());
            double cost = Convert.ToDouble(BD.Service.Where(x => x.ID == id).Select(x => x.Cost).First());
            if (disc != 0)
            {
                Price.Text = Convert.ToString(cost - disc * cost + " рублей");

            }
            else
            {
                Price.Text = Convert.ToString(cost + " рублей");
            }
        }

        public void NameService(object sender, RoutedEventArgs e)
        {
            TextBlock number = (TextBlock)sender;
            int index = Convert.ToInt32(number.Uid);
            Entities BD = new Entities();
            string a = BD.Service.Where(x => x.ID == index).Select(x => x.Title).First().ToString();
            number.Text = a;
        }

        private void Min(object sender, RoutedEventArgs e)
        {
            TextBlock min = (TextBlock)sender; int index = Convert.ToInt32(min.Uid);
            Entities BD = new Entities();
            int mins = Convert.ToInt32(BD.Service.Where(x => x.ID == index).Select(x => x.DurationInSeconds).First()) / 60;
            min.Text = " за " + mins.ToString() + " минут";
        }
        private void Sale(object sender, RoutedEventArgs e)
        {
            TextBlock pro = (TextBlock)sender;
            int index = Convert.ToInt32(pro.Uid);
            Entities BD = new Entities();
            int promo = Convert.ToInt32(Convert.ToDouble(BD.Service.Where(x => x.ID == index).Select(x => x.Discount).First()) * 100);
            if (promo > 0)
            {
                pro.Text = "* скидка " + promo + "%";
            }
            else return;
        }

        private void Button_Click_1(object sender, RoutedEventArgs e)
        {
            Button tb = (Button)sender;
            int index = Convert.ToInt32(tb.Uid);
            Entities BD = new Entities();
            Service SRVRemove = BD.Service.FirstOrDefault(x => x.ID == index);
            switch (MessageBox.Show("Удалить услугу???", "RemoveService", MessageBoxButton.YesNo, MessageBoxImage.Question))
            {
                case MessageBoxResult.Yes:
                    BD.Service.Remove(SRVRemove);
                    MessageBox.Show("Услуга удалена");
                    BD.SaveChanges();
                    MainClass.Mfrm.Navigate(new ListService());
                    break;
                case MessageBoxResult.No:
                    MessageBox.Show("Услуга не удалена");
                    break;
            }
        }

        private void Login(object sender, RoutedEventArgs e)
        {
            Auth authorization = new Auth();
            authorization.ShowDialog();
        }

        private void BackgroundLoad(object sender, RoutedEventArgs e)
        {
            Entities BD = new Entities();
            Grid serv = (Grid)sender;
            int index = Convert.ToInt32(serv.Uid);
            if (BD.Service.Where(x => x.ID == index).Select(x => x.Discount).First() > 0)
            {
                serv.Background = new SolidColorBrush(Color.FromRgb(189, 236, 182));
            }
        }

        private void Filter()
        {
            Entities BD = new Entities();
            List<Service> servs = BD.Service.ToList();
            if (RBUp.IsChecked == true)
            {
                servs = servs.OrderBy(x => x.Cost).ToList();
            }
            if (RBDown.IsChecked == true)
            {
                servs = servs.OrderByDescending(x => x.Cost).ToList();
            }
            switch (Sales.SelectedIndex)
            {
                case 1:
                    servs = servs.Where(x => x.Discount == null || (x.Discount >= 0 && x.Discount < 0.05)).ToList();
                    break;
                case 2:
                    servs = servs.Where(x => x.Discount >= 0.05 && x.Discount < 0.15).ToList();
                    break;
                case 3:
                    servs = servs.Where(x => x.Discount >= 0.15 && x.Discount < 0.30).ToList();
                    break;
                case 4:
                    servs = servs.Where(x => x.Discount >= 0.30 && x.Discount < 0.70).ToList();
                    break;
                case 5:
                    servs = servs.Where(x => x.Discount >= 0.70 && x.Discount < 1).ToList();
                    break;
                default:
                    break;
            }
            if (!string.IsNullOrWhiteSpace(Names.Text))
            {
                servs = servs.Where(x => x.Title.ToLower().Contains(Names.Text.ToLower()) || x.DescriptionWithoutNull.ToLower().Contains(Names.Text.ToLower())).ToList();
            }

            Services.ItemsSource = servs;
        }

        private void Up_Checked(object sender, RoutedEventArgs e)
        {
            Filter();
        }

        private void Down_Checked(object sender, RoutedEventArgs e)
        {
            Filter();
        }

        private void PromoChange(object sender, RoutedEventArgs e)
        {
            Filter();
        }

        private void SearchChange(object sender, TextChangedEventArgs e)
        {
            Filter();
        }
        private void Add(object sender, RoutedEventArgs e)
        {
            RedactAddService wns = new RedactAddService();
            wns.ShowDialog();
        }

        private void MakeReg(object sender, RoutedEventArgs e)
        {
            Button butt = (Button)sender;
            int index = Convert.ToInt32(butt.Uid);
            AddRecord wns = new AddRecord(index);
            wns.ShowDialog();
        }

        private void ViewReg(object sender, RoutedEventArgs e)
        {
            Record wns = new Record();
            wns.ShowDialog();
        }
        private void RedServ(object sender, RoutedEventArgs e)
        {
            Button but = (Button)sender;
            int index = Convert.ToInt32(but.Uid);
            RedactAddService wns = new RedactAddService(index);
            wns.ShowDialog();
        }
    }
}
