﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Shapes;
using System.Windows.Threading;

namespace Learn
{
    /// <summary>
    /// Логика взаимодействия для Record.xaml
    /// </summary>
    public partial class Record : Window
    {
        Entities DB = new Entities();
        DateTime notNow = new DateTime(2023, 11, 30, 08, 00, 00);
        DispatcherTimer timer = new DispatcherTimer();
        public Record()
        {
            InitializeComponent();
            timer.Interval = new TimeSpan(0, 0, 5);
            timer.Tick += new EventHandler(UpdateSource);
            DateTime notNow1 = notNow.AddDays(1);
            RegsData.ItemsSource = DB.ClientService.Where(x => (x.StartTime.Year == notNow.Year) && (x.StartTime.Month == notNow.Month) && (x.StartTime.Day == notNow.Day || x.StartTime.Day == notNow1.Day)).OrderBy(x => x.StartTime).ToList();
        }

        private void FullName(object sender, RoutedEventArgs e)
        {
            TextBlock name = (TextBlock)sender;
            int index = Convert.ToInt32(name.Uid);
            name.Text = $"{DB.Client.Where(x => x.ID == index).Select(x => x.LastName).First()} {DB.Client.Where(x => x.ID == index).Select(x => x.FirstName).First()} {DB.Client.Where(x => x.ID == index).Select(x => x.Patronymic).First()}";
        }

        private void LeftTime(object sender, RoutedEventArgs e)
        {
            TextBlock time = (TextBlock)sender;
            int index = Convert.ToInt32(time.Uid);
            TimeSpan hour = new TimeSpan(1, 0, 0);
            TimeSpan lefttime = (DB.ClientService.Where(x => x.ID == index).Select(x => x.StartTime).First() - notNow);
            if (lefttime < hour)
            {
                time.Text = "Время до начала: 0:" + lefttime.TotalMinutes % 60;
                time.Foreground = System.Windows.Media.Brushes.IndianRed;
            }
            else
            {
                time.Text = "Время до начала: " + Convert.ToInt32(lefttime.TotalMinutes / 60) + ":" + lefttime.TotalMinutes % 60;
            }

        }

        private void UpdateSource(object sender, EventArgs e)
        {
            DateTime notNow1 = notNow.AddDays(1);
            RegsData.ItemsSource = DB.ClientService.Where(x => (x.StartTime.Year == notNow.Year) && (x.StartTime.Month == notNow.Month) && (x.StartTime.Day == notNow.Day || x.StartTime.Day == notNow1.Day)).OrderBy(x => x.StartTime).ToList();
        }
    }
}
