﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Shapes;

namespace Learn
{
    /// <summary>
    /// Логика взаимодействия для RedactAddService.xaml
    /// </summary>
    public partial class RedactAddService : Window
    {
        Entities BD = new Entities();
        Service serv = new Service();
        bool flag = false;
        public RedactAddService()
        {
            InitializeComponent();
            flag = true;
        }

        public RedactAddService(int id)
        {
            InitializeComponent();
            serv = BD.Service.Where(x => x.ID == id).First();
            ServName.Text = serv.Title;
            Price.Text = serv.Cost.ToString();
            Duration.Text = serv.DurationInSeconds.ToString();
            Disc.Text = serv.Description;
            Promo.Text = serv.Discount.ToString();
        }

        private void FixChanges(object sender, RoutedEventArgs e)
        {
            if (Check(ServName.Text, Convert.ToInt32(Duration.Text)))
            {
                serv.Title = ServName.Text;
                serv.Cost = Convert.ToDecimal(Price.Text);
                serv.DurationInSeconds = Convert.ToInt32(Duration.Text);
                serv.Description = Disc.Text;
                serv.Discount = Convert.ToDouble(Promo.Text);
                if (flag)
                {
                    BD.Service.Add(serv);
                    BD.SaveChanges();
                }
                else
                {
                    BD.SaveChanges();
                }
                MessageBox.Show("Услуга успешно добавлена / отредактирована");
                MainClass.Mfrm.Navigate(new ListService());;
                this.Close();
            }
            else
            {
                MessageBox.Show("Название услуги уже существует или длительность услуги превышает 4 часа");
            }
        }

        public bool Check(string name, int seconds)
        {
            if (BD.Service.Where(x => x.Title == name).First() == null && seconds <= 14400 && seconds > 0)
            {
                return true;
            }
            else
            {
                return false;
            }
        }
    }
}
